package se.sogeti.jd.crazysnake.shakeasnake;

import java.util.List;

import se.citerus.crazysnake.Position;

public final class FruitArray {

    private FruitArray() {
        // Empty
    }

    public static Pos[] create(List<Position> positions) {
        int size = positions.size();
        Pos[] fruits = new Pos[size];
        for (int index = 0; index < size; index++) {
            Position position = positions.get(index);
            fruits[index] = Pos.valueOf(position.getX(), position.getY());
        }
        return fruits;
    }

    public static boolean contains(Pos[] fruits, Pos pos) {
        for (int index = 0; index < fruits.length; index++) {
            if (fruits[index] == pos) {
                return true;
            }
        }
        return false;
    }

    public static int remove(Pos[] fruits, Pos pos) {
        for (int index = 0; index < fruits.length; index++) {
            if (fruits[index] == pos) {
                fruits[index] = null;
                return index;
            }
        }
        return -1;
    }

    public static void add(Pos[] fruits, Pos pos, int index) {
        fruits[index] = pos;
    }
}
