package se.sogeti.jd.crazysnake.shakeasnake;

import se.citerus.crazysnake.Direction;

/**
 * Contains info needed to undo a move.
 *
 * @author Johan Dykstrom
 */
public final class UndoInfo {

	/** The position of my last tail part before moving. */
	private Pos myLastPart;

	/** My direction before moving. */
	private Direction myDirection;

    /** My score before moving. */
	private int myScore;

	/** The position of his last tail part moving. */
	private Pos hisLastPart;

	/** His direction before moving. */
	private Direction hisDirection;

    /** His score before moving. */
	private int hisScore;

    // -----------------------------------------------------------------------

	/** The number of turns remaining until the snakes grows. */
	private long turnsUntilGrowth;

	/** True if the snakes should shrink again when undoing the move. */
    private boolean shrink;

    // -----------------------------------------------------------------------

    /** The index of a fruit I eat, or -1 if none. */
    private int myFruitIndex;

    /** The index of a fruit he eats, or -1 if none. */
    private int hisFruitIndex;

    // -----------------------------------------------------------------------

	public void setMyLastPart(Pos myLastPart) {
		this.myLastPart = myLastPart;
    }

	public Pos getMyLastPart() {
		return myLastPart;
	}

	public void setMyDirection(Direction myDirection) {
		this.myDirection = myDirection;
	}

	public Direction getMyDirection() {
		return myDirection;
	}

	public void setMyScore(int myScore) {
		this.myScore = myScore;
	}

	public int getMyScore() {
		return myScore;
	}

    // -----------------------------------------------------------------------

	public void setHisLastPart(Pos hisLastPart) {
		this.hisLastPart = hisLastPart;
	}

	public Pos getHisLastPart() {
		return hisLastPart;
	}

	public void setHisDirection(Direction hisDirection) {
		this.hisDirection = hisDirection;
	}

	public Direction getHisDirection() {
		return hisDirection;
	}

	public void setHisScore(int hisScore) {
		this.hisScore = hisScore;
	}

	public int getHisScore() {
		return hisScore;
	}

    // -----------------------------------------------------------------------

    public void setTurnsUntilGrowth(long turnsUntilGrowth) {
        this.turnsUntilGrowth = turnsUntilGrowth;
    }

    public long getTurnsUntilGrowth() {
        return turnsUntilGrowth;
    }

	public void setShrink(boolean shrink) {
		this.shrink = shrink;
	}

	public boolean getShrink() {
		return shrink;
	}

    // -----------------------------------------------------------------------

	public int getMyFruitIndex() {
        return myFruitIndex;
    }

    public void setMyFruitIndex(int myFruitIndex) {
        this.myFruitIndex = myFruitIndex;
    }
    public int getHisFruitIndex() {
        return hisFruitIndex;
    }

    public void setHisFruitIndex(int hisFruitIndex) {
        this.hisFruitIndex = hisFruitIndex;
    }
}
