package se.sogeti.jd.crazysnake.shakeasnake.api;

import se.citerus.crazysnake.Snake;
import se.citerus.crazysnake.SquareContent;
import se.citerus.crazysnake.SquareContentType;

public final class SquareContentImpl implements SquareContent {

	private SquareContentType type;

	private Snake snake;

	public SquareContentImpl(SquareContentType type, Snake snake) {
		this.type = type;
		this.snake = snake;
	}

    @Override
    public String toString() {
        switch (type) {
        case APPLE:
            return "A";
        case CHERRY:
            return "C";
        case EMPTY:
            return " ";
        case SNAKE_HEAD:
            return "O";
        case SNAKE_TAIL:
            return "o";
        case STRAWBERRY:
            return "S";
        case WALL:
            return "#";
        default:
            return "-";
        }
    }

    public void setContentType(SquareContentType type) {
        this.type = type;
    }

	@Override
	public SquareContentType getContentType() {
		return type;
	}

	public void setSnake(Snake snake) {
	    this.snake = snake;
	}

	@Override
	public Snake getSnake() {
		return snake;
	}
}
