package se.sogeti.jd.crazysnake.shakeasnake.api;

import se.citerus.crazysnake.Square;
import se.citerus.crazysnake.SquareContent;

public final class SquareImpl implements Square {

	private final SquareContentImpl content;

	public SquareImpl(SquareContentImpl content) {
		this.content = content;
	}

    @Override
    public String toString() {
        return content.toString();
    }

	@Override
	public SquareContent getContent() {
		return content;
	}

	@Override
	public boolean containsSnake() {
		switch (content.getContentType()) {
		case SNAKE_HEAD:
		case SNAKE_TAIL:
			return true;
		default:
			return false;
		}
	}

	@Override
	public boolean containsFruit() {
		switch (content.getContentType()) {
		case APPLE:
		case CHERRY:
		case STRAWBERRY:
			return true;
		default:
			return false;
		}
	}

	@Override
	public boolean containsWall() {
		switch (content.getContentType()) {
		case WALL:
			return true;
		default:
			return false;
		}
	}

	@Override
	public boolean hasSolidContent() {
		return containsSnake() || containsWall();
	}

    @Override
    public boolean isUnoccupied() {
        return !hasSolidContent();
    }
}
