package se.sogeti.jd.crazysnake.shakeasnake;

import static junit.framework.Assert.assertTrue;

import org.junit.Before;
import org.junit.Test;

import se.sogeti.jd.crazysnake.shakeasnake.Arena;
import se.sogeti.jd.crazysnake.shakeasnake.Evaluator;
import se.sogeti.jd.crazysnake.shakeasnake.Pos;
import se.sogeti.jd.crazysnake.shakeasnake.api.SquareImpl;

public class TestEvaluator {

	private SquareImpl[][] arena;

	private Evaluator evaluator;

    @Before
    public void setUp() {
        Pos.init(50, 50);

    	arena = Arena.create(50, 50);
    	evaluator = new Evaluator(50, 50);
    }

	@Test
    public void isEasyPathToPositionEasy() {
    	assertTrue(Evaluator.isEasyPathToPosition(arena, 2, 3, 5, 7));
    	assertTrue(Evaluator.isEasyPathToPosition(arena, 8, 8, 5, 7));
    	assertTrue(Evaluator.isEasyPathToPosition(arena, 1, 8, 1, 1));
    	assertTrue(Evaluator.isEasyPathToPosition(arena, 1, 1, 1, 1));
    }

    @Test
    public void isEasyPathToPositionHard() {
    	arena[4][3] = Arena.OCCUPIED_SQUARE;
    	assertTrue(Evaluator.isEasyPathToPosition(arena, 2, 3, 5, 7));
    }

    @Test
    public void isEasyPathToPositionHarder() {
    	arena[4][3] = Arena.OCCUPIED_SQUARE;
    	arena[2][6] = Arena.OCCUPIED_SQUARE;
    	// This is possible if you zigzag, but not if you go in straight lines
    	assertTrue(Evaluator.isEasyPathToPosition(arena, 2, 3, 5, 7));
    }

    @Test
    public void evaluate() {
        arena[9][11] = Arena.OCCUPIED_SQUARE;
        arena[10][11] = Arena.OCCUPIED_SQUARE;
        arena[11][11] = Arena.OCCUPIED_SQUARE;
        arena[12][11] = Arena.OCCUPIED_SQUARE;
        arena[12][10] = Arena.OCCUPIED_SQUARE;
        arena[12][9] = Arena.OCCUPIED_SQUARE;
        arena[12][8] = Arena.OCCUPIED_SQUARE;
        arena[11][8] = Arena.OCCUPIED_SQUARE;
        arena[10][8] = Arena.OCCUPIED_SQUARE;
        arena[9][8] = Arena.OCCUPIED_SQUARE;
        arena[9][9] = Arena.OCCUPIED_SQUARE;
        arena[9][10] = Arena.OCCUPIED_SQUARE;

        assertTrue(Evaluator.LOOSING_SCORE == evaluator.evaluate(arena, new Pos[0], Pos.valueOf(10, 10), Pos.valueOf(1, 1), 0, 0));
        assertTrue(Evaluator.LOOSING_SCORE != evaluator.evaluate(arena, new Pos[0], Pos.valueOf(8, 10), Pos.valueOf(1, 1), 0, 0));
    }
}
