package se.sogeti.jd.crazysnake.shakeasnake;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.junit.Before;
import org.junit.Test;

import se.citerus.crazysnake.Position;
import se.sogeti.jd.crazysnake.shakeasnake.FruitArray;
import se.sogeti.jd.crazysnake.shakeasnake.Pos;

public class TestFruitArray {

    private List<Position> source;

    @Before
    public void setUp() {
    	Pos.init(50, 50);

    	source = new ArrayList<Position>();
    	for (int index = 0; index < 15; index++) {
    	    source.add(new Position(index, index));
    	}
    }

	@Test
    public void testPerformance() {
        Pos testPos = Pos.valueOf(20, 20);
        Pos removePos = Pos.valueOf(10, 10);

        for (int i = 0; i < 2000; i++) {
    	    Pos[] array = FruitArray.create(source);
    	    FruitArray.contains(array, testPos);
    	    int index = FruitArray.remove(array, removePos);
    	    FruitArray.add(array, removePos, index);
    	    iterateArray(array, testPos);

    	    Set<Pos> set = createSet(source);
    	    containsSet(set, testPos);
    	    removeSet(set, removePos);
    	    addSet(set, removePos);
    	    iterateSet(set, testPos);
        }
    }

	// -----------------------------------------------------------------------

    private void iterateArray(Pos[] array, Pos testPos) {
        for (int index = 0; index < array.length; index++) {
            Pos pos = array[index];
            if (pos == testPos) {
                return;
            }
        }
    }

    // -----------------------------------------------------------------------

    private Set<Pos> createSet(List<Position> list) {
        Set<Pos> set = new HashSet<Pos>();
        for (Position position : list) {
            set.add(Pos.valueOf(position.getX(), position.getY()));
        }
        return set;
    }

    private boolean containsSet(Set<Pos> set, Pos pos) {
        return set.contains(pos);
    }

    private boolean removeSet(Set<Pos> set, Pos pos) {
        return set.remove(pos);
    }

    private void addSet(Set<Pos> set, Pos pos) {
        set.add(pos);
    }

    private void iterateSet(Set<Pos> set, Pos testPos) {
        for (Pos pos : set) {
            if (pos == testPos) {
                return;
            }
        }
    }
}
