package se.sogeti.jd.crazysnake.shakeasnake;

import static junit.framework.Assert.assertEquals;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.junit.Test;

import se.citerus.crazysnake.Movement;
import se.sogeti.jd.crazysnake.shakeasnake.MoveScore;
import se.sogeti.jd.crazysnake.shakeasnake.ScoreMap;

public class TestScoreMap {

	@Test
	public void getMyBestMove() {
		ScoreMap scoreMap = new ScoreMap();
		scoreMap.setScore(Movement.FORWARD, Movement.FORWARD, 100);
		scoreMap.setScore(Movement.FORWARD, Movement.LEFT, 90);
		scoreMap.setScore(Movement.FORWARD, Movement.RIGHT, 50);
		scoreMap.setScore(Movement.LEFT, Movement.FORWARD, -20);
		scoreMap.setScore(Movement.LEFT, Movement.LEFT, -30);
		scoreMap.setScore(Movement.LEFT, Movement.RIGHT, 0);
		scoreMap.setScore(Movement.RIGHT, Movement.FORWARD, 0);
		scoreMap.setScore(Movement.RIGHT, Movement.LEFT, 0);
		scoreMap.setScore(Movement.RIGHT, Movement.RIGHT, 0);
		MoveScore moveScore = scoreMap.getMyBestMove();
		assertEquals(Movement.FORWARD, moveScore.move);
		assertEquals(50, moveScore.score);
	}

    @Test
    public void testPerformance() {
        for (int i = 0; i < 100; i++) {
            Map<Movement, List<Integer>> scoreMap1 = create1();
            ScoreMap scoreMap2 = create2();

            set1(scoreMap1);
            set2(scoreMap2);

            get1(scoreMap1);
            get2(scoreMap2);
        }
    }

    // -----------------------------------------------------------------------

    private Map<Movement, List<Integer>> create1() {
        Map<Movement, List<Integer>> scoreMap1 = new HashMap<Movement, List<Integer>>();
        scoreMap1.put(Movement.FORWARD, new ArrayList<Integer>(3));
        scoreMap1.put(Movement.RIGHT, new ArrayList<Integer>(3));
        scoreMap1.put(Movement.LEFT, new ArrayList<Integer>(3));
        return scoreMap1;
    }

    private void set1(Map<Movement, List<Integer>> scoreMap1) {
        List<Integer> scores = scoreMap1.get(Movement.FORWARD);
        scores.add(10);
        scores.add(10);
        scores.add(10);
    }

    private void get1(Map<Movement, List<Integer>> scoreMap1) {
        List<Integer> scores = scoreMap1.get(Movement.FORWARD);
        scores.get(0);
        scores.get(1);
        scores.get(2);
    }

    // -----------------------------------------------------------------------

    private ScoreMap create2() {
        return new ScoreMap();
    }

    private void set2(ScoreMap scoreMap2) {
        scoreMap2.setScore(Movement.FORWARD, Movement.FORWARD, 10);
        scoreMap2.setScore(Movement.FORWARD, Movement.RIGHT, 10);
        scoreMap2.setScore(Movement.FORWARD, Movement.LEFT, 10);
    }

    private void get2(ScoreMap scoreMap2) {
        scoreMap2.getScore(Movement.FORWARD, Movement.FORWARD);
        scoreMap2.getScore(Movement.FORWARD, Movement.RIGHT);
        scoreMap2.getScore(Movement.FORWARD, Movement.LEFT);
    }
}
