package se.sogeti.jd.crazysnake.shakeasnake.api;

import static junit.framework.Assert.assertEquals;
import static junit.framework.Assert.assertTrue;

import org.junit.Before;
import org.junit.Test;

import se.sogeti.jd.crazysnake.shakeasnake.Pos;
import se.sogeti.jd.crazysnake.shakeasnake.api.SnakeImpl;

public class TestSnakeImpl {

    private SnakeImpl snake;

    @Before
    public void setUp() {
        snake = new SnakeImpl();
    }

    @Test
    public void getMoveTo() {
    	snake.setHeadPosition(Pos.valueOf(1, 2));

    	// Move without growing
    	snake.moveTo(Pos.valueOf(1, 3), false);
        assertEquals(1, snake.getLength());
        assertEquals(Pos.valueOf(1, 3), snake.getHeadPosition());
        assertEquals(0, snake.getTail().size());

        // Move and grow
    	snake.moveTo(Pos.valueOf(1, 4), true);
        assertEquals(2, snake.getLength());
        assertEquals(Pos.valueOf(1, 4), snake.getHeadPosition());
        assertEquals(1, snake.getTail().size());
        assertTrue(snake.getTail().contains(Pos.valueOf(1, 3)));
    }

    @Test
    public void getBackTo() {
    	snake.setHeadPosition(Pos.valueOf(1, 2));

    	// Move without growing
    	snake.moveTo(Pos.valueOf(1, 3), false);
    	snake.backTo(Pos.valueOf(1, 2), false);
        assertEquals(1, snake.getLength());
        assertEquals(Pos.valueOf(1, 2), snake.getHeadPosition());
        assertEquals(0, snake.getTail().size());

        // Move and grow
    	snake.moveTo(Pos.valueOf(1, 3), false);
    	snake.moveTo(Pos.valueOf(1, 4), true);
    	snake.backTo(Pos.valueOf(1, 3), true);
        assertEquals(1, snake.getLength());
        assertEquals(Pos.valueOf(1, 3), snake.getHeadPosition());
        assertEquals(0, snake.getTail().size());

        // Move some more
    	snake.moveTo(Pos.valueOf(1, 3), false);
    	snake.moveTo(Pos.valueOf(1, 4), true);
    	snake.moveTo(Pos.valueOf(1, 5), true);
    	snake.moveTo(Pos.valueOf(1, 6), true);
        assertEquals(4, snake.getLength());
        assertEquals(Pos.valueOf(1, 6), snake.getHeadPosition());
        assertEquals(3, snake.getTail().size());
        assertTrue(snake.getTail().contains(Pos.valueOf(1, 3)));
        assertTrue(snake.getTail().contains(Pos.valueOf(1, 4)));
        assertTrue(snake.getTail().contains(Pos.valueOf(1, 5)));

    	snake.backTo(Pos.valueOf(1, 3), true);
        assertEquals(3, snake.getLength());
        assertEquals(Pos.valueOf(1, 5), snake.getHeadPosition());
        assertEquals(2, snake.getTail().size());
        assertTrue(snake.getTail().contains(Pos.valueOf(1, 3)));
        assertTrue(snake.getTail().contains(Pos.valueOf(1, 4)));
    }
}
